import React from 'react';
import Router, { IRouterInterface } from 'next-server/dist/lib/router/router';
interface ISingletonRouterBase {
    router: Router | null;
    readyCallbacks: Array<() => any>;
    ready(cb: () => any): void;
}
export interface IPublicRouterInstance extends IRouterInterface, Pick<Router, 'components' | 'push' | 'replace' | 'reload' | 'back' | 'prefetch' | 'beforePopState'> {
    events: typeof Router['events'];
}
export interface ISingletonRouter extends ISingletonRouterBase, IPublicRouterInstance {
}
declare const _default: ISingletonRouter;
export default _default;
export { default as withRouter } from './with-router';
export declare function useRouter(): any;
export declare function useRequest(): any;
export declare const createRouter: (pathname: string, query: any, as: string, __3: {
    initialProps: any;
    pageLoader: any;
    Component: React.ComponentType<{}>;
    App: React.ComponentType<{}>;
    err?: Error | undefined;
}) => Router;
export declare function makePublicRouterInstance(router: Router): IPublicRouterInstance;
