import React from 'react';
import { NextComponentType, IContext } from 'next-server/dist/lib/utils';
import { IPublicRouterInstance } from './router';
export declare type WithRouterProps = {
    router: IPublicRouterInstance;
};
export declare type ExcludeRouterProps<P> = Pick<P, Exclude<keyof P, keyof WithRouterProps>>;
export default function withRouter<P extends WithRouterProps, C = IContext>(ComposedComponent: NextComponentType<C, any, P>): React.ComponentClass<ExcludeRouterProps<P>>;
