import PropTypes from 'prop-types';
import { Component } from 'react';
import { IDocumentContext, IDocumentInitialProps, IDocumentProps } from 'next-server/dist/lib/utils';
export { IDocumentContext, IDocumentInitialProps, IDocumentProps };
export interface IOriginProps {
    nonce?: string;
    crossOrigin?: string;
}
export interface IDocumentComponentContext {
    readonly _documentProps: IDocumentProps;
    readonly _devOnlyInvalidateCacheQueryString: string;
}
export default class Document extends Component<IDocumentProps> {
    static childContextTypes: {
        _documentProps: PropTypes.Requireable<any>;
        _devOnlyInvalidateCacheQueryString: PropTypes.Requireable<string>;
    };
    static getInitialProps({ renderPage }: IDocumentContext): Promise<IDocumentInitialProps>;
    context: IDocumentComponentContext;
    getChildContext(): IDocumentComponentContext;
    render(): JSX.Element;
}
export declare class Html extends Component {
    static contextTypes: {
        _documentProps: PropTypes.Requireable<any>;
    };
    static propTypes: {
        children: PropTypes.Validator<string | number | boolean | {} | PropTypes.ReactElementLike | PropTypes.ReactNodeArray>;
    };
    context: IDocumentComponentContext;
    render(): JSX.Element;
}
export declare class Head extends Component<IOriginProps> {
    static contextTypes: {
        _documentProps: PropTypes.Requireable<any>;
        _devOnlyInvalidateCacheQueryString: PropTypes.Requireable<string>;
    };
    static propTypes: {
        nonce: PropTypes.Requireable<string>;
        crossOrigin: PropTypes.Requireable<string>;
    };
    context: IDocumentComponentContext;
    getCssLinks(): (JSX.Element | null)[] | null;
    getPreloadDynamicChunks(): JSX.Element[];
    getPreloadMainLinks(): (JSX.Element | null)[] | null;
    render(): JSX.Element;
}
export declare class Main extends Component {
    static contextTypes: {
        _documentProps: PropTypes.Requireable<any>;
        _devOnlyInvalidateCacheQueryString: PropTypes.Requireable<string>;
    };
    context: IDocumentComponentContext;
    render(): JSX.Element | "__NEXT_AMP_RENDER_TARGET__";
}
export declare class NextScript extends Component<IOriginProps> {
    static contextTypes: {
        _documentProps: PropTypes.Requireable<any>;
        _devOnlyInvalidateCacheQueryString: PropTypes.Requireable<string>;
    };
    static propTypes: {
        nonce: PropTypes.Requireable<string>;
        crossOrigin: PropTypes.Requireable<string>;
    };
    context: IDocumentComponentContext;
    getDynamicChunks(): JSX.Element[];
    getScripts(): (JSX.Element | null)[] | null;
    static getInlineScriptSource(documentProps: IDocumentProps): string;
    render(): JSX.Element | null;
}
